<script lang="ts" setup>
import type { CascaderProps } from 'element-plus';
import { storeToRefs } from 'pinia';
import { onMounted, ref } from 'vue';
import { useFabriqueStore } from '../stores/fabrique';


const store = useFabriqueStore();
const { selectFabrique } = useFabriqueStore();
const { regions, fabriques } = storeToRefs(store);

const props:CascaderProps = {
  expandTrigger: 'hover',
};

const value: any = ref([]);

const options: any = ref([
]);

onMounted(async () => {
  await store.fetchRegions();
  await store.fetchFabriques();

  regions.value.forEach(element => {
    options.value.push(
      {
        value: element.name,
        label: element.name,
        children: [
          ...fabriques.value.filter(item => item.region.id == element.id).map(item => ({ value: item.name, label: item.name })),
        ]
      }
    );
  });

  value.value = store.selected.name;
})

function selectFabriqueFromCascader() {
  const selectedFabrique: any = fabriques.value.filter(item => item.name == value.value[1]);
  selectFabrique(selectedFabrique[0]);
}
</script>

<template>
  <el-cascader 
        placeholder="Sélectionnez une fabrique"
        :options="options"
        @change="selectFabriqueFromCascader()"
        v-model="value"
        :props="props"
         :show-all-levels="false" />

</template>


